(* 
   file     : $CAT_DIR/Library/Real.ML
   platform : PolyML 3.2 and Isabelle94-8/HOL
   version  : 1.0b  (16.07.98)
   notes    : This structure is based on Dave Berry's `Real' from
              the Edinburgh ML-Library (db@uk.ac.ed.lfcs).

   This file should disappear when using SML/NJ 110.
*)

signature REAL =
sig

  val real:   int  -> real
  val floor:  real -> int
  val round:  real -> int
  val ceil:   real -> int
  val trunc:  real -> int
  val string: real -> string

end;

structure Real: REAL =
struct

  val real = real;

  val floor = floor;

  val string = PolyML.makestring;

  fun round r =
	let
          fun rnd r = floor (r + 0.5);
	in
          if r < 0.0 then ~ (rnd (~ r)) else rnd r
	end;

  fun ceil r = floor (r + 1.0);

  fun trunc r =	if r < 0.0 then ~ (floor (~ r)) else floor r;

end;


