(* 
   file     : $CAT_DIR/root.ML
   platform : PolyML 3.2 and Isabelle94-8/HOL
   version  : 1.0b  (16.07.98)
   notes    : This file is assumed to reside in CATs root directory, which
              must be given as a string to `CAT_DIR'. It assumes that
              it has been invoked from Isabelle/HOL and then loads all
              the files necessary for CAT.
*)

(* Modify the following line to your needs. *)
val CAT_DIR = "/full/path/to/CAT";

let

  val basic       = ["Basics",
                     "Real"];
  val basic_files = map (fn x => "Library/" ^ x ^ ".ML") basic;

  val simp       = ["IntSemantics",
                    "IntSimplifier"];
  val simp_files = map (fn x => "IntSimplifier/" ^ x ^ ".ML") simp;

  val supinf       = ["ArithSemantics",
                      "PASimplifier",
                      "ILPSemantics",
                      "ILPSolver",
                      "ExtILPSolver",
                      "SupInf"];
  val supinf_files = map (fn x => "SupInf/" ^ x ^ ".ML") supinf;

  val oracle       = ["ExtBinOracle"];
  val oracle_files = map (fn x => "ExtBin/" ^ x ^ ".ML") oracle;


  fun apply g []      = ()
    | apply g (x::xs) = (g x; apply g xs);

in

  (* load external reasoners *)

 (apply use basic_files;
  apply use simp_files;
  apply use supinf_files;


  (* load Isabelle theory *)

  apply use oracle_files;

  use_thy "ExtBin/ExtBin")

end;
